package frontend

import (
	"github.com/eiannone/keyboard"

	"git.smsvc.net/pomodoro/ChronoTomato/internal/websocket"

	ChronoTomato "git.smsvc.net/pomodoro/ChronoTomato/pkg/models"
	GoTomato "git.smsvc.net/pomodoro/GoTomato/pkg/models"
)

func UpdateLoop(client websocket.Client, config ChronoTomato.Config, channel <-chan GoTomato.ServerMessage) {
	var message GoTomato.ServerMessage

	keysEvents, _ := keyboard.GetKeys(1)
	defer keyboard.Close()

	for {
		select {
		case message = <-channel:
			desktopNotifications(message)
			terminalOutput(message)
		case keypress := <-keysEvents:
			if !keyhandler(keypress, client, config, message) {
				return
			}
		case <-websocket.Done:
			return
		}
	}
}
